# 5 min ArduPilot Analysis

## Scope

This is an example project that let you analyze and review the code of **[Ardupilot Copter-4.5.3](https://ardupilot.org/)** in 5 min or less.

![ArduPilot LOGO](ardupilot_logo.jpg)

## Requirements

- [ ] Have Docker installed on your machine (only if you want to do the analysis yourself)
- [ ] Have Git installed on your machine
- [ ] Have a license key for SciTools Understand with DevOps Enabled (Later, we will say the key is (LICENSE_KEY))
- [ ] We assume the host is Windows, but feel free to adjust some command to match on Mac or Linux

**Have Questions?** : Contact US.Sales@Emenda.com

## 2 Options: Do it or Not!

- [ ] Option 1: Only open the results, as followed:

WINDOWS
```
git clone https://gitlab.com/EmendaUSA/demos/5-min-ardupilot-analysis-x-compile
cd .\5-min-ardupilot-analysis-x-compile\results
.\OpenInUnderstand.bat
```
UNIX
```
git clone https://gitlab.com/EmendaUSA/demos/5-min-ardupilot-analysis-x-compile
cd ./5-min-ardupilot-analysis-x-compile/results
./OpenInUnderstand.bash
```
**After the first open, you can simply reopen the project in Understand. No need to use the script**

- [ ] Option 2: Create it yourself, by using the instructions provided in the next paragraph!

## You are the doing it! Great! Ready, Set, Go!

- On the **HOST** (your machine), run:

```
git clone https://gitlab.com/EmendaUSA/scitools-devops
cd scitools-devops\Docker Images\scitools-runner
.\download-scitools.cmd
.\download-scitools-essential.cmd
.\build
docker network create "ci-network"
.\run_bash_container.cmd
```
If all goes well, you are now at the prompt of a bash shell with a prompt looking like `scitools_user@24e09d56fa3c:~$`

- In the **CONTAINER** (at the prompt), run:

SUDO password is "pass"
```
sudo apt-get install gcc-arm-linux-gnueabihf gcc-arm-linux-gnueabi g++-arm-linux-gnueabihf pip
alias python=python3
python -m pip install empy==3.3.4 pexpect future
git clone https://github.com/ArduPilot/ardupilot
cd ardupilot
git checkout Copter-4.5.3
./Tools/environment_install/install-prereqs-ubuntu.sh -y
. ~/.profile
dos2unix modules/waf/waf-light
sudo usermod -a -G dialout scitools_user
./waf configure --board=navio2
bear -- ./waf copter
```
Make sure to replace (LICENSE_KEY) by your license key!
```
und -setlicensecode (LICENSE_KEY)
```
Not **this is where the embedded part comes in play!!!**

Run the following command:
```
extract_compilers_from_compilecommands.bash -json compile_commands.json
```
You will see that 3 compilers were used, namely arm-linux-gnueabihf-gcc, arm-linux-gnueabihf-g++ and gcc.

We want to only get the code that used arm-linux-gnueabihf-gcc and arm-linux-gnueabihf-g++ 

So we'll extract a new compile_commands.json as followed:

```
filter_compilers_in_compilecommands.bash -json ./compile_commands.json -out ./compile_commands.json.filtered -compiler /usr/bin/arm-linux-gnueabihf-g++ -compiler /usr/bin/arm-linux-gnueabihf-gcc
cp ./compile_commands.json ./compile_commands.json.SAVED
cp ./compile_commands.json.filtered ./compile_commands.json

```

Now, we can create the database, but we will use the arm compiler, not gcc in the arguments !

```
create_database_advanced.bash -db scitools.und -cpp -gcc /usr/bin/arm-linux-gnueabihf-gcc
remove_symlinks.bash -dir . -pattern "*.[ch]*"
und add -cmake ./compile_commands.json -analyzelater -onetime -db scitools.und 
und analyze -db scitools.und
zip_database_advanced.bash -db scitools.und/ -zip scitools.zip
und -deregisterlicensecode
```
**Do not exit or kill the container just yet !!!**

Select a (DIRECTORY) on your host.

- On the **HOST** (your machine), _**modify**_ and run:
```
docker cp scitools-runner-testing:/home/scitools_user/ardupilot/scitools.zip (DIRECTORY)
```

- In the **CONTAINER** (at the prompt), run:
```
exit
```
This will close the container

- Finally, On the **HOST** (your machine), _**modify**_ and run:
```
und -setlicensecode (LICENSE_KEY)
cd (DIRECTORY)
tar.exe -xf .\scitools.zip
und settings -C++AddFoundSystemFiles off -db .\scitools.und
und add -root DEPENDENCIES_USR=".\usr" -db .\scitools.und
und analyze -db .\scitools.und
understand .\scitools.und
```
This will open Understand with Ardupilot analyzed!

Enjoy!

## I may get 1 error, is that normal?

```
/home/scitools_user/ardupilot/ArduCopter/GCS_Copter.cpp
    Error: 'gnu/stubs-soft.h' file not found
    File: /usr/arm-linux-gnueabihf/include/gnu/stubs.h Line: 7 Col: 11
```

This is something to do with symlinks that are not copied. 

The content on my machine for stubs-soft.h, please create 5-min-ardupilot-analysis-x-compile/results/usr/arm-linux-gnueabihf/include/gnu/stubs-soft.h and re-analyze if you get this error.

```
/* This file is automatically generated.
   It defines a symbol `__stub_FUNCTION' for each function
   in the C library which is a stub, meaning it will fail
   every time called, usually setting errno to ENOSYS.  */

#ifdef _LIBC
# error Applications may not define the macro _LIBC
#endif

#define __stub___compat_create_module
#define __stub___compat_get_kernel_syms
#define __stub___compat_query_module
#define __stub_chflags
#define __stub_fchflags
#define __stub_gtty
#define __stub_revoke
#define __stub_setlogin
#define __stub_sigreturn
#define __stub_stty
```

## I want to do this on another project. Help me!

It's really simple, you only have to change a few lines...

Replace all the pre-built instructions by the package you need.

Replace `bear -- ./waf copter` by `bear -- <YOUR MAKE>`...

**There are options to work with any build OS, any Cross Compilation or any tool chain. Please contact US.Sales@Emenda.com**